> For the complete documentation index, see [llms.txt](https://docs.release.com/llms.txt). Markdown versions of documentation pages are available by appending `.md` to page URLs; this page is available as [Markdown](https://docs.release.com/reference-documentation/account-settings/environment-handles.md).

# Environment handles

Create custom, unique resource pools for your environments.

An environment "handle" is a pre-generated, unique identifier that can be used for deterministic resource pools, such as environment URLs. For example, you can use an environment handle to create deterministic URLs for your environments for OAuth applications.

In Release, Professional account-holders can create a custom handle name and specify the number of resource handles to use it with. One of these resource handles can be "checked out" by an environment, which will then display the handle in its domain name.

For example, the end result of your environment handle being inserted into an environment's domain URL would look something like this:

`https://service-${env_id}-appname.releaseapp.io`

This is no different to a regular ephemeral environment space, except that your environment handle `${env_id}` is allocated from the handle pool.

## Create an environment handle

Select the **Env Handles** tab in Account Settings. In the Environment Handles page, click the **New** button.

![List of Environment Handles](https://585411240-files.gitbook.io/~/files/v0/b/gitbook-x-prod.appspot.com/o/spaces%2F-M1neGLLQ0sDXeK6ooSo%2Fuploads%2Fgit-blob-a19cc8545b1f5d9b772498e0b224fac6b3131fdc%2Fenv_handle_example.png?alt=media\&token=f8ff4f36-a354-4978-be0a-baf9a64163a7)

In the modal window that opens, enter a name for your handle and how many handles you need. Click **Create**.

![Create Handle modal window](https://585411240-files.gitbook.io/~/files/v0/b/gitbook-x-prod.appspot.com/o/spaces%2F-M1neGLLQ0sDXeK6ooSo%2Fuploads%2Fgit-blob-738b268044887bde8a2d3eda34bafc4efaac30e2%2Fenv_handle_create.png?alt=media\&token=d2c6c8c8-c369-47b5-94f3-eb73d6c0b8c5)

## View environment handle details

In the Environment Handle Details page, you can see the name of each resource handle and which environment currently has it checked out. Notice how each resource handle name begins with the base handle name, followed by an incrementing index number. This is what will appear in the environment's URL.

![](https://585411240-files.gitbook.io/~/files/v0/b/gitbook-x-prod.appspot.com/o/spaces%2F-M1neGLLQ0sDXeK6ooSo%2Fuploads%2Fgit-blob-4cbccaa11bff392770382d124cee5daba4eb3848%2Fenv-handles.png?alt=media\&token=9f658581-ecfd-4dbf-8df0-3275c4a08d15)

## Add the environment handle to your Application Template

In order for an environment to check out a unique handle, add the following to your [Application Template](https://docs.releasehub.com/reference-documentation/application-settings/application-template):

```
environment_templates:
- name: ephemeral
  datasets:
  - name: handle_name
```

{% hint style="info" %}
URL handle pools are only applied during environment creation and cannot be changed or applied retroactively to an existing environment.
{% endhint %}

## Environment-specific environment variables

Environment handles allow you to set specific environment variables for each individual environment. For example, you may have a set of third-party service tokens that require a unique ID for each environment for testing purposes. This is a common pattern for services like Firebase or Twilio. You can provide each environment with a specific set of environment variables to be applied to that environment.

To add an environment variable to a handle, expand the section below the environment handle and click the plus sign. Insert the key and value in the relevant fields and click the check mark to save your changes.

![Adding a specific environment value to the "llama" environment handle.](https://585411240-files.gitbook.io/~/files/v0/b/gitbook-x-prod.appspot.com/o/spaces%2F-M1neGLLQ0sDXeK6ooSo%2Fuploads%2Fgit-blob-919a5db95e65603e1b46965ae5e244c5526ca0eb%2Fenvironment-handles-variables.png?alt=media\&token=ed6e169f-1027-4acb-b616-874f2f9ae2a2)

Remove an environment variable from a handle by clicking the trash sign next to it.


---

# Agent Instructions
This documentation is published with GitBook. GitBook is the documentation platform designed so that both humans and AI agents can read, navigate, and reason over technical content effectively. Learn more at gitbook.com.

## Querying This Documentation
If you need additional information that is not directly available in this page, you can query the documentation by asking a question.

Perform an HTTP GET request on the following URL with the `ask` and `goal` query parameters:

```
GET https://docs.release.com/reference-documentation/account-settings/environment-handles.md?ask=<question>&goal=<user_goal>
```

`ask` is the immediate question: it should be specific, self-contained, and written in natural language.
`goal` is what the user is ultimately trying to achieve, the reason they need the answer. Sharing it helps GitBook give you a better, more relevant answer. A goal is most helpful when it describes the outcome the user wants rather than restating the question. For example, with `ask=how do I create an API token`, a goal like `automate deployments from our CI pipeline` lets GitBook tailor the answer to that use case.

The response will contain a direct answer to the question and relevant excerpts and sources from the documentation.

Use this mechanism when the answer is not explicitly present in the current page, you need clarification or additional context, or you want to retrieve related documentation sections.
